//erstelle Auswahl.
function CIRCLE(left,top,right,bottom,antiAlias){
  var circleSelection = charIDToTypeID( "setd" );
  var descriptor = new ActionDescriptor();
  var id71 = charIDToTypeID( "null" );
  var ref5 = new ActionReference();
  var id72 = charIDToTypeID( "Chnl" );
  var id73 = charIDToTypeID( "fsel" );
  ref5.putProperty( id72, id73 );
  descriptor.putReference( id71, ref5 );
  var id74 = charIDToTypeID( "T   " );
  var desc12 = new ActionDescriptor();
  var top1 = charIDToTypeID( "Top " );
  var top2 = charIDToTypeID( "#Pxl" );
  desc12.putUnitDouble( top1, top2, top );
  var left1 = charIDToTypeID( "Left" );
  var left2 = charIDToTypeID( "#Pxl" );
  desc12.putUnitDouble( left1, left2, left );
  var bottom1 = charIDToTypeID( "Btom" );
  var bottom2 = charIDToTypeID( "#Pxl" );
  desc12.putUnitDouble( bottom1, bottom2, bottom );
  var right1 = charIDToTypeID( "Rght" );
  var right2 = charIDToTypeID( "#Pxl" );
  desc12.putUnitDouble( right1, right2, right );
  var id83 = charIDToTypeID( "Elps" );
  descriptor.putObject( id74, id83, desc12 );
  var id84 = charIDToTypeID( "AntA" );
  descriptor.putBoolean( id84, antiAlias );
  executeAction( circleSelection, descriptor, DialogModes.NO );
}


//erstelle Vordergrundfarbe.
function FGCOLOR(r,g,b){
var colorRef = new SolidColor; 
colorRef.rgb.red = r; 
colorRef.rgb.green = g; 
colorRef.rgb.blue = b; 
foregroundColor = colorRef;
}


//flle Auswahl.
function FILL(opacity){
  app.activeDocument.selection.fill(foregroundColor,mode,opacity);
}


//berechne Kreisformel.
function CIRCMATH(angle, rad, xpos, ypos){
  radian = angle / 180 * Math.PI;
  x = Math.cos(radian)*rad+xpos;
  y = Math.sin(radian)*rad+ypos;
}


//erstelle neue Ebene.
function NEWLAYER(){
  app.activeDocument.artLayers.add();
}


//vereine Ebene mit darunterliegender.
function MERGELAYER(){
  var mergeLayer = charIDToTypeID( "MrgL" );
  var descriptor = new ActionDescriptor();
  executeAction( mergeLayer, descriptor, DialogModes.NO );
}


//hebe Auswahl auf.
function DESELECT(){
  app.activeDocument.selection.deselect();
}


//Variabeldeklarationen.
var xpos=0;
var ypos=0;
var oldx=0;
var oldy=0;
var outradian=0;
var innradian=0;
var innangle=0;
var dots=0;
var dotvol=0;
var maxruns=0;
var maxcorners=0;
var count=0;
var mode=ColorBlendMode.NORMAL;


//Programm.
//Userdialoge.
xpos = prompt("Bildmittelpunkt X-Achse:\n\nWert in Pixel angeben.", 320);
ypos = prompt("Bildmittelpunkt Y-Achse:\n\nWert in Pixel angeben.", 200);
outradian = prompt("Grsse des usseren Radius:\n\nWert in Pixel angeben.", 100);
innradian = prompt("Grsse des inneren Radius:\n\nWert in Pixel angeben.", 50);
dots = prompt("Anzahl zu setzender Punkte:\n\nKleinstmglicher Wert ist 1. Je kleiner die Zahl, desto genauer das Ergebnis.\n\nProgramm kann jederzeit mit der ESCAPE-Taste abgebrochen werden.", 5);
dotvol = prompt("Grsse des zu setzenden Punktes:\n\nWert in Pixel angeben.", 2);
maxruns = prompt("Anzahl Programmdurchlufe:\n\nProgramm kann jederzeit mit der ESCAPE-Taste abgebrochen werden.", 5);
maxcorners = prompt("Formwert:\n\nVerndert die Form.", 3);

//Eingaben in Zahlen umwandeln.
xpos=1*xpos;
ypos=1*ypos;
outradian=1*outradian;
innradian=1*innradian;
dots=1*dots;
dotvol=1*dotvol;
maxruns=1*maxruns;
maxcorners=1*maxcorners;

//definiere Farbe.
FGCOLOR(255, 0, 0);
//Erstelle neue Ebene um nicht auf Hintergrundebene zu zeichnen.
NEWLAYER();

//Programmschleife.
//Anzahl Durchlufe.
for(runs=1;runs<=maxruns;runs++){

//ussere Kreis.
for (outangle=0;outangle<360;outangle++){
  CIRCMATH(outangle, outradian, xpos, ypos);
  oldx=x;
  oldy=y;
  
  //innere Kreis.
  for (corner=0;corner<maxcorners;corner++){
    CIRCMATH(-innangle, innradian, oldx, oldy);
    innangle++;
    count++;

    //zeichne jeden xten Punkt.
    if (count==dots){
      NEWLAYER();
      CIRCLE(x-dotvol,y-dotvol,x+dotvol,y+dotvol,true);
      FILL(100);
      MERGELAYER();
      count=0;
    }
  }
}
//stelle Variabeln zurck fr nchsten Durchlauf.
innangle = runs*10;
innradian = 50+(runs*5);
x=0;
y=0;
oldx=0;
oldy=0;
}

//deselektiere letzte Auswahl.
DESELECT();